
/*
Eagles Bulletin Board System
Copyright (C) 1994, Ray Rocker, rrrocker@rock.b11.ingr.com
                                rock@seabass.st.usm.edu
                                72673.2105@compuserve.com

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "client.h"
#include <ctype.h>

char permtab[MAX_CLNTCMDS];
char *currentboard = currboard;

/*
   Read menus are still hardcoded. We should fix this one day.
*/

int MainReadHelp(), MailReadHelp();
int MailDisplay(), MailDelete(), MailDelRange();
int MailReply(), GroupReply(), Forward(), SequentialRead();
int FileMenu(), FileHelp(), FileReadHelp();
int ReadMenuSelect();
int PostDisplay(), PostDelete(), PostMessage(), PostDelRange(), PostMark();
int PostEdit();
int FileDownload(), FileView(), FileReadMenuProto();
int FileReceive(), FileReadMenuSelect(), FileForward();

READMENUITEM mainreadlist[] = {
	{
	'r',             PostDisplay,       0,           C_READMSG,
        "r               Read current message\n",
	"r               б\n"
	},
	{
	' ',             PostDisplay,       0,           C_READMSG,
        "<space>         Read current message\n",
	"<space>         б\n"
	},
        {
	CTRL('P'),       PostMessage,       OPEN_POST,   C_POST,
	"CTRL-P          Post a message on this board\n",
	"CTRL-P          ۾\n"
	},
	{
	's',		 ReadMenuSelect,    0,           C_BNAMES,
	"s               Select a new board\n",
	"s                \n"
	},
	{
	'S',		 SequentialRead,    0,           C_ENUMHDRS,
	"S               Sequentially read new messages from cursor\n",
	"S               ʴ б\n"
	},
	{
        'd',             PostDelete,        0,           C_DELMSG,
        "d               Delete current message (if owned)\n",
	"d               ڱ \n"
	},
	{
	'D',             PostDelRange,      OPEN_MANAGE, C_DELRANGE,
	"D               Delete range of messages\n",
	"D                ؼ \n"
	},
	{
	'm',		 PostMark,	    OPEN_MANAGE, C_MARKMSG,
	"m               Mark message for non-deletion\n",
	"m                ʰ ǥϱ\n"
	},
	{
	'E',		 PostEdit,	    OPEN_MANAGE, C_REPLACEMSG,
	"E               Edit a post\n",
	"E                ϱ\n"
	},
	{
	'F',             Forward,           0,           C_FORWARDMSG,
        "F               Forward post to your home mailbox\n",
	"F                email  \n"
	},
	{
        'h',             MainReadHelp,      0,           0,
        "h               Get this help screen\n",
	"h               \n"
	},
	{
        CTRL('J'),       MainReadHelp,      0,           0,
        NULL,
	NULL
	},
	{
        '\0',            NULL,              0,           0,
        NULL,
	NULL
	}
};

READMENUITEM mailreadlist[] = {
	{
	'r',             MailDisplay,       0,           C_READMSG,
        "r               Read current message\n",
	"r                б\n"
	},
	{
        'R',             MailReply,         OPEN_POST,   C_MAIL,
	"R               Reply to sender of current message\n",
	"R                ϱ\n"
	},
	{
	'G',             GroupReply,        OPEN_POST,   C_MAIL,
        "G               Reply to sender and all other recipients\n", 
	"G               ̿ ٸ  ڿ ϱ\n"
	},
	{
        'd',             MailDelete,        OPEN_MANAGE, C_DELMSG,
        "d               Delete current message\n",
	"d                \n"
	},
	{
	'D',             MailDelRange,      OPEN_MANAGE, C_DELRANGE,
	"D               Delete range of mail messages\n",
	"D               ؼ  \n"
	},
	{
	'F',             Forward,           0,           C_FORWARDMSG,
        "F               Forward mail to your home mailbox\n",
	"F               email   \n"
	},
	{
        'h',             MailReadHelp,      0,           0,
        "h               Get this help screen\n",
	"h               \n"
	},
	{
        CTRL('J'),       MailReadHelp,      0,           0,
        NULL, NULL
	},
	{
        '\0',            NULL,              0,           0,
        NULL, NULL
	}
};

READMENUITEM filereadlist[] = {
#if !REMOTE_CLIENT
	{
        't',             FileReadMenuProto, 0,           C_SETPROTO,
        "t               Set download protocol\n",
	"t               ٿε  ϱ\n"
	},
	{
        'v',             FileView,          0,           C_DOWNLOAD,
	"v               View a text file\n",
	"v               ؽƮ ȭ  \n"
	},
#endif
	{
        'r',             FileReceive,       0,           C_DOWNLOAD,
        "r               Recieve (download) selected file\n",
	"r                ȭ ٿε ϱ\n"
	},
	{
	'F',             FileForward,       0,           C_FORWARDFILE,
        "F               Mail file to yourself -- uuencodes if binary\n",
        "F               email  \n"
	},
	{
        's',             FileReadMenuSelect, 0,          C_FBNAMES,
        "s               Select a new file board\n",
	"s               ȭϺ ϱ\n"
	},
	{
        'h',             FileReadHelp,      0,           0,
        "h               Get this help screen\n",
	"h               \n"
	},
	{
        CTRL('J'),       FileReadHelp,      0,           0,
        NULL,
	NULL
	},
	{
        '\0',            NULL,              0,           0,
        NULL,
	NULL
	}
};

DoReadHelp(p, flags)
READMENUITEM *p ;
int flags;
{
  extern int lang;
  while(p->cmdkey) {
    if (HasReadMenuPerm(p->openaccess, flags) && HasPerm(p->permaccess))
      {
	if (lang && p->khelpstr)
	  {
	    prints(p->khelpstr);
	  }
	else
	  {
	    if (p->helpstr)
	      prints(p->helpstr);
	  }
      }
    p++ ;
  }
}

MovementReadHelp()
{
  extern int lang;

  standout();
  if (lang)
    prints("Ŀ  \n");
  else
    prints("Movement Commands\n");
  standend();
  if (lang)
  {
    prints("p                ۷\n");
    prints("n                ۷\n");
    prints("P                \n");
    prints("N                \n");
    prints("## <cr>          ۷\n");
    prints("$                ۷\n");
  }
  else
  {
    prints("p               Previous Message\n");
    prints("n               Next Message\n");
    prints("P               Previous Page\n");
    prints("N               Next Page\n");
    prints("## <cr>         Goto Message ##\n");
    prints("$               Goto Last Message\n");
  }
}

MiscReadHelp()
{
  extern int lang;

  if (lang)
  {
    prints("CTRL-L          ȭ ٽñ׸\n");
    prints("e               б ޴ \n");
  }
  else
  {
    prints("CTRL-L          Redraw Screen\n");
    prints("e               EXIT Read Menu\n");
  }
}

ReadMenuHelp(title, list, flags)
char *title;
READMENUITEM *list;
int flags;
{
  extern int lang;
  clear();
  standout();
  prints(title);
  standend();
  move(2,0);
  MovementReadHelp();
  prints("\n");
  standout();
  if (lang)
    prints("Ÿ ɵ\n");
  else
    prints("Miscellaneous Commands\n");
  standend();
  DoReadHelp(list, flags);
  MiscReadHelp();
  pressreturn();
  clear();
  return FULLUPDATE;    
}

/*ARGSUSED*/
MailReadHelp(hptr, curr, num, flags)
void *hptr;
LONG curr, num, flags;
{
  extern int lang;
  int rc;

  if (lang)
    rc = ReadMenuHelp("ü б \n", mailreadlist, flags);
  else
    rc = ReadMenuHelp("Mail Read Menu Help Screen\n", mailreadlist, flags);
  return (rc);
}

/*ARGSUSED*/
MainReadHelp(hptr, curr, num, flags)
void *hptr;
LONG curr, num, flags;
{
  extern int lang;
  int rc;
  
  if (lang)
    rc = ReadMenuHelp(" б \n", mainreadlist, flags);
  else
    rc = ReadMenuHelp("Read Menu Help Screen\n", mainreadlist, flags);

  return (rc);
}

/*ARGSUSED*/
FileReadHelp(hptr, curr, num, flags)
void *hptr;
LONG curr, num, flags;
{
  extern int lang;
  int rc;

  if (lang)
    rc = ReadMenuHelp("ȭ \n", filereadlist, flags);
  else
    rc = ReadMenuHelp("Download Menu Help Screen\n", filereadlist, flags);
  return (rc);
}

NotImpl()
{
  extern int lang;

  clear();
  if (lang)
    prints("   غ ȵǾϴ.\n");
  else
    prints("This function is not yet implemented.\n");
  pressreturn();
  return FULLUPDATE;
}

EndMenu()
{
  return EXITMENU;
}

SetPermTable()
{
  memcpy(permtab, myinfo.access, MAX_CLNTCMDS);
}

HasPerm(perm)
int perm;
{
  if (perm == 0) return 1;
  else if (perm < 0 || perm >= MAX_CLNTCMDS) return 0;
  else return (permtab[perm]-'0');
}

HasReadMenuPerm(perm, flags)
int perm, flags;
{
  if (perm == 0) return 1;
  else return (perm & flags);
}

int
MenuGetch()
{
  char c;
  while (1) {
    c = igetch();
    if (myisprint(c)) break;
    if (c == '\r' || c == '\n' || c == '\010' || c == '\177') {
      c = '\n';
      break;
    }
    if (c == CTRL('L')) {
      redoscr() ;  
    }
  }
  return c;
}
