
/*
Eagles Bulletin Board System
Copyright (C) 1994, Ray Rocker, rrrocker@rock.b11.ingr.com
                                rock@seabass.st.usm.edu
                                72673.2105@compuserve.com

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#define	AD_FILE_KR	"etc/ad.dkim.kr"
#define	AD_FILE_EN	"etc/ad.dkim.en"

#include "client.h"
#include <ctype.h>
#include <malloc.h>

extern LOGININFO myinfo;
extern char *currentboard;
char *_menudesc_file;

/* New Menu Function */

int GetMenuIndex(t)
unsigned int t ;
{
    t = (t | 0x20) - 'a' ;
    return t % MAXMENUSZ ;
}

char InterpretMenuAction(action) 
char *action;
{
  if(action[0] != '$')
    return action[0] ;
  if(bbs_check_mail())
    return action[2] ;
  return action[1] ;
}

extern NMENU *bigMenuList ;

NMENU *menuEnt[MAXMENUDEPTH] ;
int currMenuEnt = -1 ;


/*ARGSUSED*/
int 
NDoMenu(menu_name)
char *menu_name ;
{
  int found, update = FULLUPDATE;
  char oldcmd = 'h', cmd ;
  int comm_loc, len;
  NMENU *msp ;
  NMENUITEM *item = NULL ;
  char buf[40];
  extern int lang;
  
  for(msp = bigMenuList;msp;msp=msp->next)
    if(!strcmp(menu_name,msp->menu_id))
      break ;
  if(!msp || currMenuEnt == MAXMENUDEPTH)
    return 0 ;
  currMenuEnt++ ;
  menuEnt[currMenuEnt] = msp ;
  if (myinfo.lastlogin == 0 || BITISSET(myinfo.flags, FLG_SHARED)) cmd = 'H';
  else cmd = InterpretMenuAction(msp->menu_default) ;
  while (update != EXITMENU) {
      if (PagePending()) {
          if (Answer()) update = FULLUPDATE;
      }
      if (update == FULLUPDATE || update == PARTUPDATE) {
          update == FULLUPDATE ? clear() : move(0,0);
          if(!strcmp(msp->menu_title,"*")) {
            extern BBSINFO serverinfo ;
	    standout();
            prints("%s",serverinfo.boardname) ;
	    standend();
            clrtoeol();
	    refresh();
          } else {
	    standout();
	    if (lang && msp->kmenu_title && *msp->kmenu_title) {
		prints("%s", msp->kmenu_title);
	    } else {
		prints("%s",msp->menu_title);
	    }
	    standend();
            clrtoeol();
	    refresh();
	  }
          move(0, t_columns - 45);
          if (currentboard[0] == '\0') {
	    c_msg(INFO_NO_BOARD_SELECTED, FALSE);
          } else {
	    if (lang)
              prints("*   : %s *", currentboard);
	    else
              prints("* Current Board: %s *", currentboard);
	  }
          move(1,0);
	  if (lang && msp->kmenu_prompt && *msp->kmenu_prompt) {
	    register int i;
	    register char *p;

	    prints("%s",msp->kmenu_prompt);
	    for (p=msp->kmenu_prompt, i=0; (*p); i++, p++);
	    comm_loc = i;
	  } else {
	    prints("%s",msp->menu_prompt);
	    comm_loc = strlen(msp->menu_prompt) ;
	  }
          clrtoeol();
      }
      if (bbs_check_mail()) {
	  move(0, t_columns - 13);
          standout();
	  c_msg(INFO_MAIL, FALSE);
          standend();
          clrtoeol();
          refresh();
      }
      while(cmd != '\n') {
          item = msp->menucommands[GetMenuIndex(cmd)] ;
          if(item != NULL && HasPerm(item->enabled)) {
              move(1,comm_loc);
	      len = comm_loc;
              standout();
	      if (lang && item->kname && *item->kname) {
		prints("%s", item->kname) ;
		len += strlen(item->kname);
	      } else {
		prints("%s", item->name) ;
		len += strlen(item->name);
	      }
	      standend();
              clrtoeol();

	      sprintf(buf, "[%s/%s/%s]",
			myinfo.editor, myinfo.terminal, myinfo.username);
	      move (1, t_columns - strlen(buf) - 1);
	      prints(buf);
              move(1, len);
          } else {
              bell();
              cmd = oldcmd;
          }
          oldcmd = cmd;
          cmd = MenuGetch();
          if (!isalpha(cmd) && cmd != '\n') {
              bell();
              cmd = oldcmd;
          }
      }
      item = msp->menucommands[GetMenuIndex(oldcmd)] ;
      if (item != NULL) {
          update = (item->action_func)(item->action_arg);
          BITCLR(update, FETCHNEW | NEWDIRECT);     
          if (update & MENUERROR) 
            cmd = InterpretMenuAction(item->error_action);
          else 
            cmd = InterpretMenuAction(item->default_action) ;
      }
  }
  currMenuEnt-- ;
  return FULLUPDATE;
}


do_help()
{
    NMENU *mp ;
    NMENUITEM *mip ;
    ACCOUNT acct;
    register char *ptr;
    register int i, j;
    FILE *fp;
    extern int lang;

    if(currMenuEnt < 0)
      return ;
    j = t_columns - 1;
    mp = menuEnt[currMenuEnt] ;
    move(2,0) ;
    clrtoeol() ;
    standout() ;
    for (i=0; i<20; i++) prints(" ");
    if (lang) {
      if (mp->kmenu_id && *mp->kmenu_id) {
        prints("%s %s", mp->kmenu_id, "޴ ");
	i += (strlen(mp->kmenu_id) + 12);
      } else {
        prints("%s %s", mp->menu_id, "޴ ");
	i += (strlen(mp->menu_id) + 12);
      }
    } else {
      prints("%s %s", mp->menu_id, "Menu Help Screen");
	i += (strlen(mp->menu_id) + 17);
    }
    for (; i < j; i++) prints(" ");
    standend() ;
    prints("\n");

    for(mip=mp->commlist;mip;mip=mip->next)
    {
      if(HasPerm(mip->enabled)) {
        char blanks[256];

        clrtoeol() ;

	if (lang && mip->khelp && *mip->khelp) {
	  for (i=0, ptr=mip->khelp; (*ptr)&&(*ptr == ' '); ptr++, i++)
	    blanks[i] = ' ';
	  blanks[i-1] = '\0';
	  prints("%s", blanks);

	  standout();
	  prints(" ");
	  standend();
	  refresh();

          prints("%s", ptr) ;
	  i+= strlen(ptr);
	  standout();
	  prints(" ");
	  standend();
	  i++;
	  for (; i < j; i++)
	    prints(" ");
          prints("\n");
	} else {
	  for (i=0, ptr=mip->help; (*ptr)&&(*ptr == ' '); ptr++, i++)
	    blanks[i] = ' ';
	  blanks[i-1] = '\0';
	  prints("%s", blanks);

	  standout();
	  prints(" ");
	  standend();
	  refresh();

          prints("%s", ptr) ;
	  i+= strlen(ptr);

	  standout();
	  prints(" ");
	  standend();
	  i++;
	  for (; i < j; i++)
	    prints(" ");
          prints("\n");
	}
      }
    }
    standout();
    for (i=0; i<j; i++) prints(" ");
    prints("\n");
    standend();

    /* this gatta be ONE line ad. for now - DKIM */
    if (lang) {
      if (fp = fopen(AD_FILE_KR, "r")) {
	char buf[81];
	if (fgets(buf, 80, fp)) {
	  /* buf should have EOLN */
	  prints(buf);
	  standout();
	  for (i=0; i<j; i++) prints(" ");
	  prints("\n");
	  standend();
	}
	fclose(fp);
      }
    } else {
      if (fp = fopen(AD_FILE_EN, "r")) {
	char buf[81];
	if (fgets(buf, 80, fp)) {
	  /* buf should have EOLN */
	  prints(buf);
	  standout();
	  for (i=0; i<j; i++) prints(" ");
	  prints("\n");
	  standend();
	}
	fclose(fp);
      }
    }
    clrtobot() ;
    return PARTUPDATE;
}

do_echo(s)
char *s ;
{
    clear() ;
    prints("%s",s) ;
    pressreturn() ;
    return FULLUPDATE ;
}

exec_func(s)
char *s ;
{
    int i ;
    char buf[4096] ;
    char *p, *q ;
    SHORT mode ;
    
    parse_default() ;
    strncpy(buf,s,sizeof(buf)) ;
    p=strchr(buf,':') ;
    if(p) {
      *p='\0' ;
      q=strchr(p+1,':') ;
      if(q) {
            *q='\0';
            mode = atoi(q+1);            
      }
      parse_environment(p+1) ;
    }
      
    if (mode > 1) bbs_set_mode(mode);
    clear() ;
    refresh() ;
    i = do_exec(buf,NULL) ;
    clear() ;
    if (mode > 1) bbs_set_mode(M_UNDEFINED);
    return FULLUPDATE ;
}
 
exec_func_w_pause(s)
char *s ;
{
    int i ;
    
    char buf[4096] ;
    char *p, *q ;
    SHORT mode ;

    parse_default() ;
    strncpy(buf,s,sizeof(buf)) ;
    p=strchr(buf,':') ;
    if(p) {
        *p='\0' ;
        q=strchr(p+1,':') ;
        if(q) {
            *q='\0';
            mode = atoi(q+1);            
        }
        parse_environment(p+1) ;
    }
      
    if (mode > 1) bbs_set_mode(mode) ;
    clear() ;
    refresh() ;
    i = do_exec(buf,NULL) ;
    pressreturn() ;
    clear() ;
    if (mode > 1) bbs_set_mode(M_UNDEFINED) ;
    return FULLUPDATE ;
}

int do_pipe_more() ;

int revised_pipe_more(s)
char *s ;
{
    char buf[4096] ;
    char *p ;
    
    parse_default() ;
    strncpy(buf,s,sizeof(buf)) ;
    p=strchr(buf,':') ;
    if(p) {
        *p='\0' ;
        parse_environment(p+1) ;
    }
      
    do_pipe_more(buf) ;
}

struct funcs {
    char *funcname ;
    int (*funcptr)() ;
} ;

int NotImpl(), EndMenu(), XyzMenu(), AdminMenu(), MailMenu(), TalkMenu();
int MainHelp(), XyzHelp(), AdminHelp(), MailHelp(), TalkHelp();
int ShowDate(), Welcome(), BoardInfo(), GnuInfo(), EditWelcome();
int MainReadHelp(), MailReadHelp();
int FileMenu(), FileHelp(), FileReadHelp();
int AllUsers(), OnlineUsers(), SetPasswd(), SetUsername(), SetAddress();
int ShortList(), Monitor();
int SetTermtype(), ShowOwnInfo(), AddAccount(), DeleteAccount();
int SetUserData(), SetUserPerms(), ToggleCloak(), ToggleExempt();
int Query(), QueryEdit();
int MailSend(), GroupSend(), ReadNewMail(), MailRead();
int NetMailSend();
int MailDisplay(), MailDelete(), MailDelRange();
int MailReply(), GroupReply(), Forward();
int Visit(), BoardCounts(), Zap(), ReadNew(), SequentialRead();
int Boards(), SelectBoard(), AddBoard(), DeleteBoard(), ChangeBoard();
int SetBoardMgrs();
int FtpPost(), Post(),  MainRead(), ReadMenuSelect();
int PostDisplay(), PostDelete(), PostMessage(), PostDelRange(), PostMark();
int PostEdit();
int FileBoards(), FileSelect(), FileDownload();
int FileUpload(), FileReceive(), FileReadMenuSelect();
int Chat(), Kick(), Talk(), SetPager(), SetOverrides(), Irc();
int Routing();
int SignatureEdit();
#if !REMOTE_CLIENT
int SelectEditor(), SelectProtocol(), FileReadMenuProto(), FileView();
#endif
int SetLang(), DeleteMe(), Xit();

struct funcs funclist[] = {
    "exec", exec_func,
    "exec.pause", exec_func_w_pause,
    "exec.more", revised_pipe_more,
    "echo", do_echo,
    "NotImpl",NotImpl,
    "EndMenu",EndMenu,
    "Help",do_help,
    "Menu",NDoMenu,
    "ShowDate",ShowDate,
    "Welcome", Welcome,
    "BoardInfo",BoardInfo,
    "GnuInfo",GnuInfo,
    "EditWelcome",EditWelcome,
    "AllUsers",AllUsers,
    "OnlineUsers",OnlineUsers,
    "SetPasswd",SetPasswd,
    "SetUsername",SetUsername,
    "SetAddress",SetAddress,
    "ShortList",ShortList,
    "Monitor",Monitor,
    "SetTermtype",SetTermtype,
    "ShowOwnInfo",ShowOwnInfo,
    "AddAccount",AddAccount,
    "DeleteAccount",DeleteAccount,
    "SetUserData",SetUserData,
    "SetUserPerms",SetUserPerms,
    "ToggleCloak",ToggleCloak,
    "ToggleExempt",ToggleExempt,
    "Query",Query,
    "QueryEdit",QueryEdit,
    "MailSend",MailSend,
    "NetMailSend",NetMailSend,
    "GroupSend",GroupSend,
    "ReadNewMail",ReadNewMail,
    "MailRead",MailRead,
    "Visit",Visit,
    "BoardCounts",BoardCounts,
    "Zap",Zap,
    "ReadNew",ReadNew,
    "Boards",Boards,
    "SelectBoard",SelectBoard,
    "AddBoard",AddBoard,
    "DeleteBoard",DeleteBoard,
    "ChangeBoard",ChangeBoard,
    "SetBoardMgrs",SetBoardMgrs,
    "Post",Post,
    "FtpPost",FtpPost,
    "MainRead",MainRead,
    "FileBoards",FileBoards,
    "FileSelect",FileSelect,
    "FileDownload",FileDownload,
#if !REMOTE_CLIENT
    "SelectProtocol",SelectProtocol,
#endif
    "FileUpload",FileUpload,
    "Irc",Irc,
    "Routing", Routing,
    "Chat",Chat,
    "Kick",Kick,
    "Talk",Talk,
    "SetPager",SetPager,
    "SetOverrides",SetOverrides,
#if !REMOTE_CLIENT
    "SelectEditor",SelectEditor,
#endif
    "SignatureEdit",SignatureEdit,
    "SetLang", SetLang,
    "DeleteMe", DeleteMe,
    "Xit", Xit,
    NULL,NULL
} ;

    
int (*findfunc(s))()
char *s ;
{
    int i ;
    
    for(i=0;funclist[i].funcname;i++)
      if(!strcmp(funclist[i].funcname,s))
        return funclist[i].funcptr ;
    return NULL ;
}

#if !REMOTE_CLIENT

/* NOTE: This MUST agree with ACCESSFILE location in init.c */
#define ACCESSFILE "etc/access" 

char *funcstrings[MAX_CLNTCMDS];

form_function_list()
{
    FILE *fp;
    int i;
    char buf[1024], *equals;
    for (i=0; i<MAX_CLNTCMDS; i++) funcstrings[i] = NULL;
    i = 0;
    if ((fp = fopen(ACCESSFILE, "r")) != NULL) {
      while (i<MAX_CLNTCMDS && fgets(buf, sizeof buf, fp) != NULL) {
        if (*buf == '#' || isspace(*buf)) continue;
        if ((equals = strchr(buf, '=')) != NULL) {
          *equals = '\0';
          if ((funcstrings[i] = (char *)malloc(strlen(buf)+1)) != NULL)
	    strcpy(funcstrings[i], buf);
	}
	i++;
      }
      fclose(fp);
    }
}

free_function_list()
{
    int i;
    for (i=0; i<MAX_CLNTCMDS; i++)
      if (funcstrings[i] != NULL) free(funcstrings[i]);
}

convert_cmd_to_int(s) 
char *s;
{
    int i ;
    
    for (i=0; i<MAX_CLNTCMDS; i++) {
      if (funcstrings[i] == NULL) continue;
      if (!strcmp(funcstrings[i], s)) return i;
    }
    fprintf(stderr, "does not grok '%s'\n", s);
    sleep(2);
    return -1;
}

#else /* REMOTE_CLIENT */

convert_cmd_to_int(s)
char *s;
{
    /* In the remote client, we're assuming numbers will be here */
    return 0;
}

#endif /* !REMOTE_CLIENT */

int line_num ;

ParseMenu()
{
    FILE *fp ;
    extern FILE *yyin ;
    
    if((fp = fopen(_menudesc_file,"r")) == NULL) {
        perror("open menu file") ;
        return -1 ;
    }
#if !REMOTE_CLIENT
    form_function_list();    
#endif
    yyin = fp ;
    line_num = 1 ;
    yyparse() ;
    fclose(fp) ;
#if !REMOTE_CLIENT
    free_function_list();
#endif
    return 0;
}

yywrap()
{
    return 1 ;
}

yyerror()
{
    char buf[512] ;
    sprintf(buf,"syntax error in '%s' %d.\n",_menudesc_file,line_num) ;
    do_echo(buf) ;
}
